diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/media_wysiwyg.format_form.js b/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/media_wysiwyg.format_form.js
new file mode 100644
index 00000000..f9b16f43
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/js/media_wysiwyg.format_form.js
@@ -0,0 +1,69 @@
+
+/**
+ *  @file
+ *  Attach behaviors to formatter radio select when selecting a media's display
+ *  formatter.
+ */
+
+(function ($) {
+namespace('Drupal.media.formatForm');
+
+Drupal.media.mediaFormatSelected = {};
+
+Drupal.behaviors.mediaFormatForm = {
+  attach: function (context, settings) {
+    // Add the "Submit" button inside the IFRAME that trigger the behavior of
+    // the hidden "OK" button that is outside the IFRAME.
+    // @see Drupal.media.browser.validateButtons() for more details.
+
+    // @note I think this should be handled in media.browser.js in
+    // Drupal.media.browser.validateButtons but I'm not sure how crufty this
+    // particular functionality is. We should evaluate if it is still needed.
+
+    // @TODO can these be added to the content being displayed via form_alter?
+
+    // Adding the buttons should only be done once in order to prevent multiple
+    // buttons from being added if part of the form is updated via AJAX
+    $('#media-wysiwyg-format-form').once('format', function() {
+      $('<a class="button fake-ok">' + Drupal.t('Submit') + '</a>').appendTo($('#media-wysiwyg-format-form')).bind('click', Drupal.media.formatForm.submit);
+    });
+  }
+};
+
+Drupal.media.formatForm.getOptions = function () {
+  // Get all the values
+  var ret = {};
+
+  $.each($('#media-wysiwyg-format-form .fieldset-wrapper *').serializeArray(), function (i, field) {
+    ret[field.name] = field.value;
+
+    // When a field uses a WYSIWYG format, the value needs to be extracted.
+    if (field.name.match(/\[format\]/i)) {
+      field.name = field.name.replace(/\[format\]/i, '[value]');
+      field.key  = 'edit-' + field.name.replace(/[_\[]/g, '-').replace(/[\]]/g, '');
+
+      if (Drupal.wysiwyg.instances[field.key]) {
+        // Retrieve the content from the WYSIWYG instance.
+        ret[field.name] = Drupal.wysiwyg.instances[field.key].getContent();
+
+        // Escape the double-quotes and encode it to play nicely within JSON.
+        ret[field.name] = encodeURIComponent(ret[field.name].replace(/"/g, '\\"'));
+      }
+    }
+  });
+
+  return ret;
+};
+
+Drupal.media.formatForm.getFormattedMedia = function () {
+  var formatType = $("#edit-format").val();
+  return { type: formatType, options: Drupal.media.formatForm.getOptions(), html: Drupal.settings.media.formatFormFormats[formatType] };
+};
+
+Drupal.media.formatForm.submit = function () {
+  // @see Drupal.behaviors.mediaFormatForm.attach().
+  var buttons = $(parent.window.document.body).find('#mediaStyleSelector').parent('.ui-dialog').find('.ui-dialog-buttonpane button');
+  buttons[0].click();
+}
+
+})(jQuery);
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.ckeditor.inc b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.ckeditor.inc
new file mode 100644
index 00000000..236ef4bf
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.ckeditor.inc
@@ -0,0 +1,37 @@
+<?php
+
+/**
+ * @file
+ * Provides WYSIWYG integration for CKEditor.
+ */
+
+/**
+ * Implements hook_ckeditor_plugin().
+ */
+function media_wysiwyg_ckeditor_plugin() {
+  return array(
+    'media' => array(
+      'name' => 'media',
+      'desc' => t('Plugin for inserting images from Drupal media module'),
+      'path' => base_path() . drupal_get_path('module', 'media_wysiwyg') . '/wysiwyg_plugins/media_ckeditor/',
+      'buttons' => array(
+        'Media' => array(
+          'icon' => 'images/icon.gif',
+          'label' => 'Add media',
+        ),
+      ),
+      'default' => 'f',
+    ),
+  );
+}
+
+/**
+ * Implements hook_ckeditor_plugin_alter().
+ */
+function media_wysiwyg_ckeditor_plugin_alter(&$plugins) {
+  // To ensure the ckeditor media integration is done by this module all other
+  // integrations are overwritten here. However additionally added keys will be
+  // left intact.
+  $default_plugin = media_wysiwyg_ckeditor_plugin();
+  $plugins['media'] = $default_plugin['media'] + $plugins['media'];
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.info b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.info
new file mode 100644
index 00000000..a88618bd
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.info
@@ -0,0 +1,23 @@
+name = Media WYSIWYG
+description = Adds support for embedding media using client-side WYSIWYG editors.
+package = Media
+core = 7.x
+
+dependencies[] = media
+
+test_dependencies[] = ckeditor
+test_dependencies[] = token
+test_dependencies[] = wysiwyg
+
+files[] = media_wysiwyg.test
+files[] = tests/media_wysiwyg.file_usage.test
+files[] = tests/media_wysiwyg.macro.test
+
+configure = admin/config/media/browser
+
+; Information added by Drupal.org packaging script on 2014-10-04
+version = "7.x-2.0-alpha4"
+core = "7.x"
+project = "media"
+datestamp = "1412422430"
+
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.install b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.install
new file mode 100644
index 00000000..6d2d5e49
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.install
@@ -0,0 +1,20 @@
+<?php
+
+/**
+ * @file
+ * Install, update and uninstall functions for the Media WYSIWYG module.
+ */
+
+/**
+ * Implements hook_uninstall().
+ */
+function media_wysiwyg_uninstall() {
+  // Remove variables.
+  variable_del('media_wysiwyg_wysiwyg_title');
+  variable_del('media_wysiwyg_wysiwyg_icon_title');
+  variable_del('media_wysiwyg_wysiwyg_default_view_mode');
+  variable_del('media_wysiwyg_wysiwyg_upload_directory');
+  variable_del('media_wysiwyg_wysiwyg_allowed_types');
+  variable_del('media_wysiwyg_wysiwyg_allowed_attributes');
+  variable_del('media_wysiwyg_wysiwyg_browser_plugins');
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.module b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.module
new file mode 100644
index 00000000..1fb7a834
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.module
@@ -0,0 +1,303 @@
+<?php
+
+/**
+ * @file
+ * Primarily Drupal hooks.
+ */
+
+// Functions for tracking the file usage of [[inline tags]].
+require_once dirname(__FILE__) . '/includes/media_wysiwyg.file_usage.inc';
+
+// Functions for working with [[inline tags]] and wysiwyg editors.
+require_once dirname(__FILE__) . '/includes/media_wysiwyg.filter.inc';
+
+// Functions for UUID support to embedded media.
+require_once dirname(__FILE__) . '/includes/media_wysiwyg.uuid.inc';
+
+/**
+ * Implements hook_hook_info().
+ */
+function media_wysiwyg_hook_info() {
+  $hooks = array(
+    'media_wysiwyg_token_to_markup_alter',
+    'media_wysiwyg_allowed_view_modes_alter',
+    'media_wysiwyg_format_form_prepare_alter',
+  );
+
+  return array_fill_keys($hooks, array('group' => 'media_wysiwyg'));
+}
+
+/**
+ * Implements hook_menu().
+ */
+function media_wysiwyg_menu() {
+  $items['media/%file/format-form'] = array(
+    'title' => 'Style selector',
+    'description' => 'Choose a format for a piece of media',
+    'page callback' => 'drupal_get_form',
+    'page arguments' => array('media_wysiwyg_format_form', 1),
+    'access callback' => 'file_entity_access',
+    'access arguments' => array('view', 1),
+    'file' => 'includes/media_wysiwyg.pages.inc',
+    'theme callback' => 'media_dialog_get_theme_name',
+    'type' => MENU_CALLBACK,
+  );
+
+  return $items;
+}
+
+/**
+ * Implements hook_element_info_alter().
+ */
+function media_wysiwyg_element_info_alter(&$types) {
+  $types['text_format']['#pre_render'][] = 'media_wysiwyg_pre_render_text_format';
+}
+
+/**
+ * Implements hook_form_FORM_ID_alter().
+ */
+function media_wysiwyg_form_wysiwyg_profile_form_alter(&$form, &$form_state) {
+  // Add warnings if the media filter is disabled for the WYSIWYG's text format.
+  $form['buttons']['drupal']['media']['#element_validate'][] = 'media_wysiwyg_wysiwyg_button_element_validate';
+  $form['buttons']['drupal']['media']['#after_build'][] = 'media_wysiwyg_wysiwyg_button_element_validate';
+  form_load_include($form_state, 'inc', 'media_wysiwyg', 'wysiwyg_plugins/media');
+}
+
+/**
+ * Element validate callback for the media WYSIWYG button.
+ */
+function media_wysiwyg_wysiwyg_button_element_validate($element, &$form_state) {
+  if (!empty($element['#value'])) {
+    $format = filter_format_load($form_state['build_info']['args'][0]->format);
+    $filters = filter_list_format($format->format);
+    if (empty($filters['media_filter']->status)) {
+      form_error($element, t('The <em>Convert Media tags to markup</em> filter must be enabled for the <a href="@format-link">@format format</a> in order to use the Media browser WYSIWYG button.', array(
+        '@format-link' => url('admin/config/content/formats/' . $format->format, array('query' => array('destination' => $_GET['q']))),
+        '@format' => $format->name,
+      )));
+    }
+  }
+
+  return $element;
+}
+
+/**
+ * Implements hook_form_FORM_ID_alter().
+ */
+function media_wysiwyg_form_media_admin_config_browser_alter(&$form, &$form_state) {
+  $form['wysiwyg'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('WYSIWYG configuration'),
+    '#collapsible' => TRUE,
+    '#collapsed' => FALSE,
+  );
+  $form['wysiwyg']['media_wysiwyg_wysiwyg_browser_plugins'] = array(
+    '#type' => 'checkboxes',
+    '#title' => t('Enabled browser plugins'),
+    '#options' => array(),
+    '#required' => FALSE,
+    '#default_value' => variable_get('media_wysiwyg_wysiwyg_browser_plugins', array()),
+    '#description' => t('If no plugins are selected, they will all be available.'),
+  );
+
+  $plugins = media_get_browser_plugin_info();
+
+  foreach ($plugins as $key => $plugin) {
+    $form['wysiwyg']['media_wysiwyg_wysiwyg_browser_plugins']['#options'][$key] = !empty($plugin['title']) ? $plugin['title'] : $key;
+  }
+
+  $form['wysiwyg']['media_wysiwyg_wysiwyg_upload_directory'] = array(
+    '#type' => 'textfield',
+    '#title' => t("File directory for uploaded media"),
+    '#default_value' => variable_get('media_wysiwyg_wysiwyg_upload_directory', ''),
+    '#description' => t('Optional subdirectory within the upload destination where files will be stored. Do not include preceding or trailing slashes.'),
+  );
+
+  if (module_exists('token')) {
+    $form['wysiwyg']['media_wysiwyg_wysiwyg_upload_directory']['#description'] .= t('This field supports tokens.');
+    $form['wysiwyg']['tokens'] = array(
+      '#theme' => 'token_tree',
+      '#dialog' => TRUE,
+    );
+  }
+
+  $form['wysiwyg']['media_wysiwyg_wysiwyg_allowed_types'] = array(
+    '#type' => 'checkboxes',
+    '#title' => t('Allowed types in WYSIWYG'),
+    '#options' => file_entity_type_get_names(),
+    '#default_value' => variable_get('media_wysiwyg_wysiwyg_allowed_types', array('audio', 'image', 'video', 'document')),
+  );
+
+  $form['#submit'][] = 'media_wysiwyg_admin_config_browser_pre_submit';
+}
+
+/**
+ * Manipulate values before form is submitted.
+ */
+function media_wysiwyg_admin_config_browser_pre_submit(&$form, &$form_state) {
+  $wysiwyg_browser_plugins = array_unique(array_values($form_state['values']['media_wysiwyg_wysiwyg_browser_plugins']));
+  if (empty($wysiwyg_browser_plugins[0])) {
+    variable_del('media_wysiwyg_wysiwyg_browser_plugins');
+    unset($form_state['values']['media_wysiwyg_wysiwyg_browser_plugins']);
+  }
+}
+
+/**
+ * Implements hook_filter_info().
+ */
+function media_wysiwyg_filter_info() {
+  $filters['media_filter'] = array(
+    'title' => t('Convert Media tags to markup'),
+    'description' => t('This filter will convert [[{type:media... ]] tags into markup. This must be enabled for the Media WYSIWYG integration to work with this input format.'),
+    'process callback' => 'media_wysiwyg_filter',
+    'weight' => 2,
+    // @TODO not implemented
+    'tips callback' => 'media_filter_tips',
+  );
+
+  return $filters;
+}
+
+/**
+ * Prepares the page to be able to launch the media browser.
+ *
+ * Defines default variables.
+ */
+function media_wysiwyg_include_browser_js() {
+  static $included;
+  if ($included) {
+    return;
+  }
+  $included = TRUE;
+  module_load_include('inc', 'media', 'includes/media.browser');
+  $javascript = media_browser_js();
+  foreach ($javascript as $key => $definitions) {
+    foreach ($definitions as $definition) {
+      $function = 'drupal_add_' . $key;
+      // Since the arguments to pass are variable, use call_user_func_array().
+      // This will not handle all potential drupal_add_*() functions directly
+      // but covers the js and library needed here, which are unlikely to be
+      // expanded since this function is only a workaround for a wysiwyg
+      // limitation.
+      call_user_func_array($function, $definition);
+    }
+  }
+  // Add wysiwyg-specific settings.
+  $settings = array('wysiwyg_allowed_attributes' => variable_get('media_wysiwyg_wysiwyg_allowed_attributes', _media_wysiwyg_wysiwyg_allowed_attributes_default()));
+  drupal_add_js(array('media' => $settings), 'setting');
+}
+
+/**
+ * Implements hook_wysiwyg_include_directory().
+ */
+function media_wysiwyg_wysiwyg_include_directory($type) {
+  switch ($type) {
+    case 'plugins':
+      return 'wysiwyg_plugins';
+
+      break;
+  }
+}
+
+/**
+ * Returns the default set of allowed attributes for use with WYSIWYG.
+ *
+ * @return array
+ *   An array of whitelisted attributes.
+ */
+function _media_wysiwyg_wysiwyg_allowed_attributes_default() {
+  return array(
+    'alt',
+    'title',
+    'height',
+    'width',
+    'hspace',
+    'vspace',
+    'border',
+    'align',
+    'style',
+    'class',
+    'id',
+    'usemap',
+    'data-picture-group',
+    'data-picture-align',
+    'data-picture-mapping',
+  );
+}
+
+/**
+ * Returns a drupal_render() array for just the file portion of a file entity.
+ *
+ * Optional custom settings can override how the file is displayed.
+ */
+function media_wysiwyg_get_file_without_label($file, $view_mode, $settings = array()) {
+  $file->override = $settings;
+
+  $element = file_view_file($file, $view_mode);
+
+  // The formatter invoked by file_view_file() can use $file->override to
+  // customize the returned render array to match the requested settings. To
+  // support simple formatters that don't do this, set the element attributes to
+  // what was requested, but not if the formatter applied its own logic for
+  // element attributes.
+  if (isset($settings['attributes'])) {
+    if (empty($element['#attributes'])) {
+      $element['#attributes'] = $settings['attributes'];
+    }
+
+    // While this function may be called for any file type, images are a common
+    // use-case, and image theme functions have their own structure for render
+    // arrays.
+    if (isset($element['#theme'])) {
+      // theme_image() and theme_image_style() require the 'alt' attributes to
+      // be passed separately from the 'attributes' array. (see
+      // http://drupal.org/node/999338). Until that's fixed, implement this
+      // special-case logic. Image formatters using other theme functions are
+      // responsible for their own 'alt' attribute handling. See
+      // theme_media_formatter_large_icon() for an example.
+      if (in_array($element['#theme'], array('image', 'image_style'))) {
+        if (empty($element['#alt']) && isset($settings['attributes']['alt'])) {
+          $element['#alt'] = $settings['attributes']['alt'];
+        }
+      }
+      // theme_image_formatter() and any potential replacements, such as
+      // theme_colorbox_image_formatter(), also require attribute handling.
+      elseif (strpos($element['#theme'], 'image_formatter') !== FALSE) {
+        // theme_image_formatter() requires the attributes to be
+        // set on the item rather than the element itself.
+        if (empty($element['#item']['attributes'])) {
+          $element['#item']['attributes'] = $settings['attributes'];
+        }
+
+        // theme_image_formatter() also requires alt, title, height, and
+        // width attributes to be set on the item rather than within its
+        // attributes array.
+        foreach (array('alt', 'title', 'width', 'height') as $attr) {
+          if (isset($settings['attributes'][$attr])) {
+            $element['#item'][$attr] = $settings['attributes'][$attr];
+          }
+        }
+      }
+    }
+  }
+
+  return $element;
+}
+
+/**
+ * Returns an array containing the names of all fields that perform text filtering.
+ */
+function media_wysiwyg_filter_fields_with_text_filtering($entity_type, $entity) {
+  list($entity_id, $revision_id, $bundle) = entity_extract_ids($entity_type, $entity);
+  $fields = field_info_instances($entity_type, $bundle);
+
+  // Get all of the fields on this entity that allow text filtering.
+  $fields_with_text_filtering = array();
+  foreach ($fields as $field_name => $field) {
+    if (!empty($field['settings']['text_processing'])) {
+      $fields_with_text_filtering[] = $field_name;
+    }
+  }
+
+  return $fields_with_text_filtering;
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.test b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.test
new file mode 100644
index 00000000..cdb672a1
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.test
@@ -0,0 +1,101 @@
+<?php
+
+/**
+ * @file
+ * Tests for media.module.
+ */
+
+/**
+ * Defines base class for media test cases.
+ */
+class MediaWYSIWYGTestHelper extends DrupalWebTestCase {
+
+  /**
+   * Enable media and file entity modules for testing.
+   */
+  public function setUp() {
+    $modules = func_get_args();
+    if (isset($modules[0]) && is_array($modules[0])) {
+      $modules = $modules[0];
+    }
+    $modules[] = 'media_wysiwyg';
+    parent::setUp($modules);
+  }
+
+  /**
+    * Generates markup to be inserted for a file.
+    *
+    * This is a PHP version of InsertMedia.insert() from js/wysiwyg-media.js.
+    *
+    * @param int $fid
+    *   Drupal file id
+    * @param int $count
+    *   Quantity of markup to insert
+    * @param array $attributes
+    *   Extra attributes to insert.
+    * @param array $fields
+    *   Extra field values to insert.
+    *
+    * @return string
+    *   Filter markup.
+    */
+  protected function generateJsonTokenMarkup($fid, $count = 1, array $attributes = array(), array $fields = array()) {
+    $markup = '';
+    // Merge default atttributes.
+    $attributes += array(
+      'height' => 100,
+      'width' => 100,
+      'classes' => 'media-element file_preview',
+    );
+
+    // Build the data that is used in a media tag.
+    $data = array(
+      'fid' => $fid,
+      'type' => 'media',
+      'view_mode' => 'preview',
+      'attributes' => $attributes,
+      'fields' => $fields,
+    );
+
+    // Create the file usage markup.
+    for ($i = 1; $i <= $count; $i++) {
+      $markup .= '<p>[[' . drupal_json_encode($data) . ']]</p>';
+    }
+
+    return $markup;
+  }
+
+  /**
+   * Utility function to create a test node.
+   *
+   * @param int $fid
+   *   Create the node with media markup in the body field
+    * @param array $attributes
+    *   Extra attributes to insert to the file.
+    * @param array $fields
+    *   Extra field values to insert.
+   *
+   * @return int
+   *   Returns the node id
+   */
+  protected function createNode($fid = FALSE, array $attributes = array(), array $fields = array()) {
+    $markup = '';
+    if (! empty($fid)) {
+      $markup = $this->generateJsonTokenMarkup($fid, 1, $attributes, $fields);
+    }
+
+    // Create an article node with file markup in the body field.
+    $edit = array(
+      'title' => $this->randomName(8),
+      'body[und][0][value]' => $markup,
+    );
+    // Save the article node. First argument is the URL, then the value array
+    // and the third is the label the button that should be "clicked".
+    $this->drupalPost('node/add/article', $edit, t('Save'));
+
+    // Get the article node that was saved by the unique title.
+    $node = $this->drupalGetNodeByTitle($edit['title']);
+    return $node->nid;
+  }
+
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.variable.inc b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.variable.inc
new file mode 100644
index 00000000..206905a0
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/media_wysiwyg.variable.inc
@@ -0,0 +1,42 @@
+<?php
+
+/**
+ * @file
+ * Declare Media WYSIWYG variables.
+ */
+
+/**
+ * Implements hook_variable_group_info().
+ */
+function media_wysiwyg_variable_group_info() {
+  $groups['media_wysiwyg'] = array(
+    'title' => t('Media WYSIWYG'),
+    'description' => t('Settings for Media WYSIWYG integration.'),
+    'access' => 'administer media browser',
+    'path' => 'admin/config/media/browser',
+  );
+
+  return $groups;
+}
+
+/**
+* Implements hook_variable_info().
+*/
+function media_wysiwyg_variable_info($options) {
+  $variables['media_wysiwyg_wysiwyg_title'] = array(
+    'type' => 'string',
+    'title' => t('WYSIWYG Title', array(), $options),
+    'default' => t('Media browser', array(), $options),
+    'description' => t('The WYSIWYG media plugin title.', array(), $options),
+    'group' => 'media_wysiwyg',
+  );
+  $variables['media_wysiwyg_wysiwyg_icon_title'] = array(
+    'type' => 'string',
+    'title' => t('WYSIWYG Icon Title', array(), $options),
+    'default' => t('Add media', array(), $options),
+    'description' => t('The WYSIWYG media button title to display on hover.', array(), $options),
+    'group' => 'media_wysiwyg',
+  );
+
+  return $variables;
+}
diff --git a/drupal7/sites/all/modules/media/tests/media.file.usage.test b/drupal7/sites/all/modules/media/modules/media_wysiwyg/tests/media_wysiwyg.file_usage.test
similarity index 79%
rename from drupal7/sites/all/modules/media/tests/media.file.usage.test
rename to drupal7/sites/all/modules/media/modules/media_wysiwyg/tests/media_wysiwyg.file_usage.test
index db5c614e..bd82ecfa 100644
--- a/drupal7/sites/all/modules/media/tests/media.file.usage.test
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/tests/media_wysiwyg.file_usage.test
@@ -5,7 +5,7 @@
  * Tests for the file usage in entity fields with the Media filter markup.
  */
 
-class MediaFileUsageTest extends MediaTestHelper {
+class MediaWYSIWYGFileUsageTest extends MediaWYSIWYGTestHelper {
 
   /**
    * Provide test information.
@@ -14,7 +14,7 @@ class MediaFileUsageTest extends MediaTestHelper {
     return array(
       'name' => t('File usage tracking'),
       'description' => t('Tests tracking of usage for files in text fields.'),
-      'group' => t('Media'),
+      'group' => t('Media WYSIWYG'),
     );
   }
 
@@ -22,79 +22,13 @@ class MediaFileUsageTest extends MediaTestHelper {
    * Enable media and file entity modules for testing.
    */
   public function setUp() {
-    parent::setUp(array('media', 'file_entity'));
+    parent::setUp();
 
     // Create and log in a user.
     $account = $this->drupalCreateUser(array('administer nodes', 'create article content'));
     $this->drupalLogin($account);
   }
 
-  /**
-    * Generates markup to be inserted for a file.
-    *
-    * This is a PHP version of InsertMedia.insert() from js/wysiwyg-media.js.
-    *
-    * @param int $fid
-    *   Drupal file id
-    * @param int $count
-    *   Quantity of markup to insert
-    *
-    * @return string
-    *   Filter markup.
-    */
-  private function generateFileMarkup($fid, $count = 1) {
-    $file_usage_markup = '';
-
-    // Build the data that is used in a media tag.
-    $data = array(
-      'fid' => $fid,
-      'type' => 'media',
-      'view_mode' => 'preview',
-      'attributes' => array(
-        'height' => 100,
-        'width' => 100,
-        'classes' => 'media-element file_preview',
-      )
-    );
-
-    // Create the file usage markup.
-    for ($i = 1; $i <= $count; $i++) {
-      $file_usage_markup .= '<p>[[' . drupal_json_encode($data) . ']]</p>';
-    }
-
-    return $file_usage_markup;
-  }
-
-
-  /**
-   * Utility function to create a test node.
-   *
-   * @param int $fid
-   *   Create the node with media markup in the body field
-   *
-   * @return int
-   *   Returns the node id
-   */
-  private function createNode($fid = FALSE) {
-    $markup = '';
-    if (! empty($fid)) {
-      $markup = $this->generateFileMarkup($fid);
-    }
-
-    // Create an article node with file markup in the body field.
-    $edit = array(
-      'title' => $this->randomName(8),
-      'body[und][0][value]' => $markup,
-    );
-    // Save the article node. First argument is the URL, then the value array
-    // and the third is the label the button that should be "clicked".
-    $this->drupalPost('node/add/article', $edit, t('Save'));
-
-    // Get the article node that was saved by the unique title.
-    $node = $this->drupalGetNodeByTitle($edit['title']);
-    return $node->nid;
-  }
-
   /**
    * Tests the tracking of file usages for files submitted via the WYSIWYG editor.
    */
@@ -133,7 +67,7 @@ class MediaFileUsageTest extends MediaTestHelper {
     // Create a new revision that has two instances of the file. File usage will
     // be 4.
     $node = node_load($nid);
-    $node->body[LANGUAGE_NONE][0]['value'] = $this->generateFileMarkup($fid, 2);
+    $node->body[LANGUAGE_NONE][0]['value'] = $this->generateJsonTokenMarkup($fid, 2);
     $node->revision = TRUE;
     node_save($node);
 
@@ -163,7 +97,7 @@ class MediaFileUsageTest extends MediaTestHelper {
 
     // Create a new revision that has the file on it. File usage will be 5.
     $node = node_load($nid);
-    $node->body[LANGUAGE_NONE][0]['value'] = $this->generateFileMarkup($fid, 1);
+    $node->body[LANGUAGE_NONE][0]['value'] = $this->generateJsonTokenMarkup($fid, 1);
     $node->revision = TRUE;
     node_save($node);
 
@@ -194,7 +128,7 @@ class MediaFileUsageTest extends MediaTestHelper {
 
     // Create a new revision with the file on it twice. File usage will be 4.
     $node = node_load($nid);
-    $node->body[LANGUAGE_NONE][0]['value'] = $this->generateFileMarkup($fid, 2);
+    $node->body[LANGUAGE_NONE][0]['value'] = $this->generateJsonTokenMarkup($fid, 2);
     $node->revision = TRUE;
     node_save($node);
 
@@ -206,7 +140,7 @@ class MediaFileUsageTest extends MediaTestHelper {
     // Re-save current revision with file on it once instead of twice. File
     // usage will be 3.
     $node = node_load($nid);
-    $node->body[LANGUAGE_NONE][0]['value'] = $this->generateFileMarkup($fid, 1);
+    $node->body[LANGUAGE_NONE][0]['value'] = $this->generateJsonTokenMarkup($fid, 1);
     $saved_vid = $node->vid;
     node_save($node);
 
@@ -227,7 +161,6 @@ class MediaFileUsageTest extends MediaTestHelper {
     $this->assertEqual(empty($file_uses), TRUE, t('Deleting the node removes all file uses.'));
   }
 
-
   /**
    * Tests the behavior of node and file deletion.
    */
@@ -301,5 +234,4 @@ class MediaFileUsageTest extends MediaTestHelper {
     $type = node_type_load($node->type);
     $this->assertRaw(t('@type %title has been updated.', array('@type' => $type->name, '%title' => $node->title)), t('Node without reference to deleted file saved successfully.'));
   }
-
 }
diff --git a/drupal7/sites/all/modules/media/modules/media_wysiwyg/tests/media_wysiwyg.macro.test b/drupal7/sites/all/modules/media/modules/media_wysiwyg/tests/media_wysiwyg.macro.test
new file mode 100644
index 00000000..7ac1bc4c
--- /dev/null
+++ b/drupal7/sites/all/modules/media/modules/media_wysiwyg/tests/media_wysiwyg.macro.test
@@ -0,0 +1,95 @@
+<?php
+
+/**
+ * @file
+ * Tests for ensuring media macros render properly.
+ */
+
+/**
+ * Defines media macro test cases.
+ */
+class MediaWYSIWYGWYSIWYGOverridesTest extends MediaWYSIWYGTestHelper {
+
+  /**
+   * Provide test information.
+   */
+  public static function getInfo() {
+    return array(
+      'name' => t('Media WYSIWYG WYSIWYG overrides'),
+      'description' => t('Tests that overridden attributes display correct.'),
+      'group' => t('Media WYSIWYG'),
+      'dependencies' => array('token'),
+    );
+  }
+
+  public function setUp() {
+    parent::setUp('token');
+
+    // Create and log in a user.
+    $account = $this->drupalCreateUser(array('create article content', 'administer filters', 'use text format filtered_html'));
+    $this->drupalLogin($account);
+
+    // Enable the media filter for full html.
+    $edit = array(
+      'filters[media_filter][status]' => TRUE,
+      'filters[filter_html][status]' => FALSE,
+    );
+    $this->drupalPost('admin/config/content/formats/filtered_html', $edit, t('Save configuration'));
+  }
+
+  /**
+   * Test image media overrides.
+   */
+  public function testAttributeOverrides() {
+    $files = $this->drupalGetTestFiles('image');
+    $file = file_save($files[0]);
+
+    // Create a node to test with.
+    $nid = $this->createNode($file->fid);
+
+    $this->drupalGet('node/' . $nid);
+    $this->assertRaw('width="100"', t('Image displays with default width attribute.'));
+    $this->assertRaw('height="100"', t('Image displays with default height attribute.'));
+
+    // Create a node with a style attribute.
+    $attributes = array(
+      'style' => 'float: left; width: 50px;',
+    );
+    $nid = $this->createNode($file->fid, $attributes);
+    $this->drupalGet('node/' . $nid);
+    $this->assertRaw(drupal_attributes($attributes), t('Image displays with overriden attributes.'));
+
+    // Create a node with overriden alt/title attributes.
+    $attributes = array(
+      'alt' => $this->randomName(),
+      'title' => $this->randomName(),
+    );
+    $nid = $this->createNode($file->fid, $attributes);
+    $this->drupalGet('node/' . $nid);
+    $this->assertRaw(drupal_attributes($attributes), t('Image displays with alt/title set as attributes.'));
+
+    // Create a node with overriden alt/title fields.
+    $fields = $attributes = array();
+    $attributes['alt'] = $fields['field_file_image_alt_text[und][0][value]'] = $this->randomName();
+    $attributes['title'] = $fields['field_file_image_title_text[und][0][value]'] = $this->randomName();
+
+    $nid = $this->createNode($file->fid, array(), $fields);
+    $this->drupalGet('node/' . $nid);
+    // Ensure that the alt/title from attributes display.
+    $this->assertRaw(drupal_attributes($attributes), t('Image displays with alt/title set as fields.'));
+
+    // Create a node with overriden alt/title fields as well as attributes.
+    $attributes = array(
+      'alt' => $this->randomName(),
+      'title' => $this->randomName(),
+    );
+    $fields = array(
+      'field_file_image_alt_text[und][0][value]' => $this->randomName(),
+      'field_file_image_title_text[und][0][value]' => $this->randomName(),
+    );
+    $nid = $this->createNode($file->fid, $attributes, $fields);
+    $this->drupalGet('node/' . $nid);
+    // Ensure that the alt/title from attributes display rather the field ones.
+    $this->assertRaw(drupal_attributes($attributes), t('Image displays with alt/title set as attributes overriding field values.'));
+  }
+}
